/*
arrays.c   - 20 aprile 99 - E.V.
rappresentazione concreta di un array astratto
implementa i metodi di creazione, accesso e memorizzazione
rispetto alla rappresentazione diretta sugli array del c aggiunge
l'allocazione dinamica e il controllo sugli indici
virtualizza parzialmente la dipendenza sul tipo dei dati nell'array
per una completa virtualizzazione occorrerebbe risolvere virtualizzare
le operazioni di input e output formattato
*/

#include<stdlib.h>
#include<memory.h>

typedef float V_type;

typedef struct array{
               V_type * A;
               int N;
               int M;
} array;

void main(void);
/* chiede le dimensioni dell'array, lo alloca, e lo inizializza
   a valori richiesti; inifine stampa i valori contenuti. */

int create(array * A_ptr,int N, int M);
/* alloca l'array alle dimensioni assegnate;
   restituisce 0 in caso di fallimento di malloc */

int access(array A, int n, int m, V_type * value_ptr);
/* calcola in *value_ptr l'elemento in posizione n m sull'array A;
   restituisce 0 se gli inidci sono fuori dal range
   A e' il valore dell'array per ragioni didattiche; nella pratica si
   passerebbe il puntatore per ragioni di efficienza */


int store(array * A_ptr, int n, int m, V_type value);
/* memorizza value sull'array *A_ptr in posizione n m;
   restituisce 0 se gli inidci sono fuori dal range  */


void main(void)
/* chiede le dimensioni dell'array, lo alloca, e lo inizializza
   a valori richiesti; inifine stampa i valori contenuti. */
{  V_type value;
   int N,M;
   array A;
   int n,m;

   printf("\n\n N> ");
   scanf("%d", &N);
   printf("\n M> ");
   scanf("%d", &M);
   if(create(&A,N,M)!=1)
   { printf("\n Allocation failure !");
     exit(-1);
   }

   printf("Insert values (%d X %d)",A.N,A.M);
   for(n=0;n<A.N;n++)
   { printf("\n");
     for(m=0;m<A.M;m++)
     { scanf(" %f",&value);
       store(&A,n,m,value);
     }
   }

   printf("stored values");
   for(n=0;n<A.N;n++)
   { printf("\n");
     for(m=0;m<A.M;m++)
     { access(A,n,m,&value);
      printf(" %f",value);
     }
   }
}

int create(array * A_ptr,int N, int M)
/* alloca l'array alle dimensioni assegnate;
   restituisce 0 in caso di fallimento di malloc */
{
   A_ptr->A=(V_type *)malloc(N*M*sizeof(V_type));
   if(A_ptr->A!=NULL)
   {   A_ptr->N=N;
       A_ptr->M=M;
       return 1;
   }
   else
       return 0;
}

int access(array A, int n, int m, V_type * value_ptr)
/* calcola in *value_ptr l'elemento in posizione n m sull'array A;
   restituisce 0 se gli inidci sono fuori dal range
   A e' il valore dell'array per ragioni didattiche; nella pratica si
   passerebbe il puntatore per ragioni di efficienza */
{
   if(n<A.N && n>=0 && m<A.M && m>=0)
   {        *value_ptr=A.A[n*A.M+m];
            return 1;
   }else
            return 0;
}

int store(array * A_ptr, int n, int m, V_type value)
/* memorizza value sull'array *A_ptr in posizione n m;
   restituisce 0 se gli inidci sono fuori dal range  */
{
   if(n<A_ptr->N && n>=0 && m<A_ptr->M && m>=0)
   {        A_ptr->A[n*A_ptr->M+m]=value;
            return 1;
   }else
            return 0;
}

