/*
sparse_arrays.c   - 20 aprile 99 - E.V.
rappresentazione concreta di un array astratto sparso
deriva da arrays.c

implementa i metodi di creazione, accesso e memorizzazione
rispetto alla rappresentazione diretta sugli array del c aggiunge
l'allocazione dinamica, il controllo sugli indici, E LA RAPPRSENTAZIONE
COMPATTA, virtualizza parzialmente la dipendenza sul tipo dei dati nell'array
per una completa virtualizzazione occorrerebbe risolvere virtualizzare
le operazioni di input e output formattato
*/

#include<stdlib.h>
#include<memory.h>

typedef int boolean
#define FALSE 0
#define TRUE 1

typedef float V_type;

struct array_item{
               V_type value;
               int lin;
               int col;
};

typedef struct array_s
/* la matrice sparsa e' rappresentata come un array mono-dimensionale
   di triple array_item, ciascuna contenente un valore e la sua posizione
   linea colonna;
   la matrice rappresentazione include anche le dimensioni N e M della
   matrice sparsa, il valore predominante (attribuito agli elementi non
   rappresentati) e il numero massimo di elementi diversi dal valore
   predominante;
   il valore in un singolo item vale dominant_value se l'item e' vuoto
*/
{
               struct array_item * A;
               int N;
               int M;
               int MAX;
               V_type dominant_value;
} array_s;

void main(void);
/* chiede le dimensioni dell'array sparso, il valore predominante, e il
   numero massimo di elementi diversi dal valore predominante;
   alloca l'array monodimensionale per la rappresentazione compatta,
   inizializza l'array a valori richiesti e infine stampa i valori contenuti. */

void main(void)
/* chiede le dimensioni dell'array sparso, il valore predominante, e il
   numero massimo di elementi diversi dal valore predominante;
   alloca l'array monodimensionale per la rappresentazione compatta,
   inizializza l'array a valori richiesti e infine stampa i valori contenuti. */
{  V_type value;
   int N,M,MAX;
   array_s A;
   int n,m;

   printf("\n\n N> ");
   scanf("%d", &N);
   printf("\n M> ");
   scanf("%d", &M);
   printf("\n MAX> ");
   scanf("%d", &MAX)
   printf("\n dominant> ");
   scanf("%f", &value);
   if(create(&A,N,M,MAX,value)!=1)
   { printf("\n Allocation failure !");
     exit(-1);
   }

   printf("Insert non dominant values (%d)",A.MAX);
   do{
       printf("\n line (%d to stop insertion)> ",A.N);
       scanf("%d",&n);
       if(n==A.N)
       { new_item_to_insert=FALSE;
       }else
       { new_item_to_insert=TRUE;
         printf("\n column> ");
         scanf("%d",&m);
         printf("\n value> ");
         scanf("%f",&value);
         result=store(&A,n,m,value);
         if(result==1)
         { printf("insertion succeeded !");
         }else if(result==0)
         { printf("non legal indexes !");
         }else if(result==-1)
         { printf("no more free items !")
         }
       }
   }while(new_item_to_insert==TRUE);

   printf("stored values");
   for(n=0;n<A.N;n++)
   { printf("\n");
     for(m=0;m<A.M;m++)
     { access(A,n,m,&value);
      printf(" %f",value);
     }
   }
}

int create(array_s * A_ptr,int N, int M, int MAX, V_type dominant_value)
/* alloca l'array monodimensionale per la rappresentazione sparsa
   inizializza i campi relativi alle dimensioni rappresentate e al
   valore dominante;
   inizializza a A-ptr->dominant_value il campo value degli items per
   indicare che sono liberi
   restituisce 0 in caso di fallimento di malloc */
{
   int count;

   A_ptr->A=(struct array_item *)malloc(MAX*sizeof(struct array_item));
   if(A_ptr->A!=NULL)
   {   A_ptr->N=N;
       A_ptr->M=M;
       A_ptr->MAX=MAX;
       A_ptr->dominant_value=dominant_value;
       for(count=0;count<A_ptr->MAX;count++)
         A_ptr->A[count].value=A_ptr-dominant_value
       return 1;
   }
   else
       return 0;
}

int access(array_s A, int n, int m, V_type * value_ptr)
/* calcola in *value_ptr l'elemento in posizione n m sull'array sparso:
   scandisce l'array compatto, se trova il valore lo rende, altrimente
   rende il valore dominante;
   restituisce 0 se gli indici sono fuori dal range
   A e' il valore dell'array per ragioni didattiche; nella pratica si
   passerebbe il puntatore per ragioni di efficienza */
{
   boolean found;
   int count;

   if(n<A.N && n>=0 && m<A.M && m>=0)
   {
     found=FALSE;
     count=0;
     while(found==FALSE && count<A.MAX)
     {  if(A.A[count].lin==n && A.A[count].col==m)
        { *value_ptr=A.A[count].value;
          found=TRUE;
        }
     }

     if(found==FALSE)
     { *value_ptr=A.dominant_value;}

     return 1;
   }else
   {
     return 0;
   }
}

int store(array_s * A_ptr, int n, int m, V_type value)
/* memorizza il valore value sulla rappresentazione compatta in modo
   tale da assegnare il valore value all'elemento di riga n colonna m della
   matrice sparsa;
   restituisce 0 se gli indici sono fuori dal range,
   -1 se l'array e' pieno
   1 altrimenti
*/
{
  boolean done;
  int next_item_to_test;

   if(n<A_ptr->N && n>=0 && m<A_ptr->M && m>=0)
   { 
     done=FALSE;
     next_item_to_test=0;
     do
     {

     }while(found==FALSE && next_item_to_test<a_ptr->MAX)
     if(done==TRUE)
       return 1;
     else
       return -1;
   }else
     return 0;
}

